/*
 *  DO NOT EDIT THIS FILE   (ltopts.h)
 *  
 *  It has been AutoGen-ed  Monday February 19, 2001 at 04:55:33 PM PST
 *  From the definitions    ltopts.def
 *  and the template file   options
 */

/*
 *  This file contains the programmatic interface to the Automated
 *  Options generated for the ltmain program.
 *  These macros are documented in the AutoGen info file in the
 *  "AutoOpts" chapter.  Please refer to that doc for usage help.
 */

#ifndef LTMAIN_LTOPTS_H
#define LTMAIN_LTOPTS_H

/*
 * ltmain copyright 1996-2000 Free Software Foundation - all rights reserved
 *
 * ltmain is free software.
 * 
 * You may redistribute it and/or modify it under the terms of the
 * GNU General Public License, as published by the Free Software
 * Foundation; either version 2, or (at your option) any later version.
 * 
 * ltmain is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with ltmain.  See the file "COPYING".  If not,
 * write to:  The Free Software Foundation, Inc.,
 *            59 Temple Place - Suite 330,
 *            Boston,  MA  02111-1307, USA.
 */
#include <options.h>

/*
 *  Enumeration of each option:
 */
typedef enum {
        INDEX_OPT_MODE             =  0,
        INDEX_OPT_CLEAN            =  1,
        INDEX_OPT_COMPILE          =  2,
        INDEX_OPT_EXECUTE          =  3,
        INDEX_OPT_FINISH           =  4,
        INDEX_OPT_INSTALL          =  5,
        INDEX_OPT_LINK             =  6,
        INDEX_OPT_UNINSTALL        =  7,
        INDEX_OPT_ECHO             =  8,
        INDEX_OPT_TAG              = 10,
        INDEX_OPT_DRY_RUN          = 11,
        INDEX_OPT_QUIET            = 12,
        INDEX_OPT_SILENT           = 13,
        INDEX_OPT_DEBUG            = 14,
        INDEX_OPT_CONFIG           = 15,
        INDEX_OPT_FEATURES         = 16,
        INDEX_OPT_STATIC           = 18,
        INDEX_OPT_DYNAMIC          = 19,
        INDEX_OPT_OUTPUT_FILE      = 21,
        INDEX_OPT_DLOPEN           = 23,
        INDEX_OPT_VERSION          = 25,
        INDEX_OPT_HELP             = 26,
        INDEX_OPT_MORE_HELP        = 27
} teOptIndex;

#define OPTION_CT    28
#define LTMAIN_VERSION       "@VERSION@"
#define LTMAIN_FULL_VERSION  "ltmain - Object Code Library Management Tool - Ver. @VERSION@"

/*
 *  Interface defines for all options.  Replace "n" with
 *  the UPPER_CASED option name (as in the teOptIndex
 *  enumeration above).  e.g. HAVE_OPT( MODE )
 */
#ifdef __STDC__
#define     DESC(n)     ltmainOptions.pOptDesc[INDEX_OPT_ ## n]
#else
#define     DESC(n)     ltmainOptions.pOptDesc[INDEX_OPT_/**/n]
#endif
#define     HAVE_OPT(n) (! UNUSED_OPT(&DESC(n)))
#define      OPT_ARG(n) (DESC(n).pzLastArg)
#define    STATE_OPT(n) (DESC(n).fOptState & OPTST_SET_MASK)
#define    COUNT_OPT(n) (DESC(n).optOccCt)
#define    ISSEL_OPT(n) (SELECTED_OPT(&DESC(n)))
#define ISUNUSED_OPT(n) (UNUSED_OPT(& DESC(n)))
#define  ENABLED_OPT(n) (! DISABLED_OPT(& DESC(n)))
#define  STACKCT_OPT(n) (((tArgList*)(DESC(n).optCookie))->useCt)
#define STACKLST_OPT(n) (((tArgList*)(DESC(n).optCookie))->apzArgs)
#define    CLEAR_OPT(n) STMTS( \
                DESC(n).fOptState &= OPTST_PERSISTENT;   \
                if ( (DESC(n).fOptState & OPTST_INITENABLED) == 0) \
                    DESC(n).fOptState |= OPTST_DISABLED; \
                DESC(n).optCookie = (void*)NULL )

/*
 *  Interface defines for specific options.
 */
#define VALUE_OPT_MODE           0
#define VALUE_OPT_CLEAN          1
#define SET_OPT_CLEAN   STMTS( \
        DESC(COMPILE).optActualIndex = 1; \
        DESC(COMPILE).optActualValue = VALUE_OPT_CLEAN; \
        DESC(COMPILE).fOptState &= OPTST_PERSISTENT; \
        DESC(COMPILE).fOptState |= OPTST_SET | OPTST_EQUIVALENCE )
#define VALUE_OPT_COMPILE        2
#define WHICH_OPT_COMPILE        (DESC(COMPILE).optActualValue)
#define WHICH_IDX_COMPILE        (DESC(COMPILE).optActualIndex)
#define SET_OPT_COMPILE   STMTS( \
        DESC(COMPILE).optActualIndex = 2; \
        DESC(COMPILE).optActualValue = VALUE_OPT_COMPILE; \
        DESC(COMPILE).fOptState &= OPTST_PERSISTENT; \
        DESC(COMPILE).fOptState |= OPTST_SET )
#define VALUE_OPT_EXECUTE        3
#define SET_OPT_EXECUTE   STMTS( \
        DESC(COMPILE).optActualIndex = 3; \
        DESC(COMPILE).optActualValue = VALUE_OPT_EXECUTE; \
        DESC(COMPILE).fOptState &= OPTST_PERSISTENT; \
        DESC(COMPILE).fOptState |= OPTST_SET | OPTST_EQUIVALENCE )
#define VALUE_OPT_FINISH         4
#define SET_OPT_FINISH   STMTS( \
        DESC(COMPILE).optActualIndex = 4; \
        DESC(COMPILE).optActualValue = VALUE_OPT_FINISH; \
        DESC(COMPILE).fOptState &= OPTST_PERSISTENT; \
        DESC(COMPILE).fOptState |= OPTST_SET | OPTST_EQUIVALENCE )
#define VALUE_OPT_INSTALL        5
#define SET_OPT_INSTALL   STMTS( \
        DESC(COMPILE).optActualIndex = 5; \
        DESC(COMPILE).optActualValue = VALUE_OPT_INSTALL; \
        DESC(COMPILE).fOptState &= OPTST_PERSISTENT; \
        DESC(COMPILE).fOptState |= OPTST_SET | OPTST_EQUIVALENCE )
#define VALUE_OPT_LINK           6
#define SET_OPT_LINK   STMTS( \
        DESC(COMPILE).optActualIndex = 6; \
        DESC(COMPILE).optActualValue = VALUE_OPT_LINK; \
        DESC(COMPILE).fOptState &= OPTST_PERSISTENT; \
        DESC(COMPILE).fOptState |= OPTST_SET | OPTST_EQUIVALENCE )
#define VALUE_OPT_UNINSTALL      7
#define SET_OPT_UNINSTALL   STMTS( \
        DESC(COMPILE).optActualIndex = 7; \
        DESC(COMPILE).optActualValue = VALUE_OPT_UNINSTALL; \
        DESC(COMPILE).fOptState &= OPTST_PERSISTENT; \
        DESC(COMPILE).fOptState |= OPTST_SET | OPTST_EQUIVALENCE )
#define VALUE_OPT_ECHO           8
#define SET_OPT_ECHO   STMTS( \
        DESC(COMPILE).optActualIndex = 8; \
        DESC(COMPILE).optActualValue = VALUE_OPT_ECHO; \
        DESC(COMPILE).fOptState &= OPTST_PERSISTENT; \
        DESC(COMPILE).fOptState |= OPTST_SET | OPTST_EQUIVALENCE )
#define VALUE_OPT_TAG            10
#define VALUE_OPT_DRY_RUN        'n'
#define VALUE_OPT_QUIET          12
#define WHICH_OPT_QUIET          (DESC(QUIET).optActualValue)
#define WHICH_IDX_QUIET          (DESC(QUIET).optActualIndex)
#define VALUE_OPT_SILENT         13
#define VALUE_OPT_DEBUG          14
#define VALUE_OPT_CONFIG         15
#define VALUE_OPT_FEATURES       16
#define VALUE_OPT_STATIC         18
#define SET_OPT_STATIC   STMTS( \
        DESC(STATIC).optActualIndex = 18; \
        DESC(STATIC).optActualValue = VALUE_OPT_STATIC; \
        DESC(STATIC).fOptState &= OPTST_PERSISTENT; \
        DESC(STATIC).fOptState |= OPTST_SET )
#define DISABLE_OPT_STATIC   STMTS( \
        DESC(STATIC).fOptState &= OPTST_PERSISTENT; \
        DESC(STATIC).fOptState |= OPTST_SET | OPTST_DISABLED; \
        DESC(STATIC).pzLastArg  = (char*)NULL )
#define VALUE_OPT_DYNAMIC        19
#define SET_OPT_DYNAMIC   STMTS( \
        DESC(DYNAMIC).optActualIndex = 19; \
        DESC(DYNAMIC).optActualValue = VALUE_OPT_DYNAMIC; \
        DESC(DYNAMIC).fOptState &= OPTST_PERSISTENT; \
        DESC(DYNAMIC).fOptState |= OPTST_SET )
#define DISABLE_OPT_DYNAMIC   STMTS( \
        DESC(DYNAMIC).fOptState &= OPTST_PERSISTENT; \
        DESC(DYNAMIC).fOptState |= OPTST_SET | OPTST_DISABLED; \
        DESC(DYNAMIC).pzLastArg  = (char*)NULL )
#define VALUE_OPT_OUTPUT_FILE    'o'
#define VALUE_OPT_DLOPEN         23

#define VALUE_OPT_VERSION        'v'
#define VALUE_OPT_HELP           '?'
#define VALUE_OPT_MORE_HELP      '!'

/*
 *  Interface defines not associated with particular options
 */
#define  ERRSKIP_OPTERR STMTS( ltmainOptions.fOptSet &= ~OPTPROC_ERRSTOP )
#define  ERRSTOP_OPTERR STMTS( ltmainOptions.fOptSet |= OPTPROC_ERRSTOP )
#define  RESTART_OPT(n) STMTS( \
                ltmainOptions.curOptIdx = (n); \
                ltmainOptions.pzCurOpt  = (char*)NULL )
#define    START_OPT    RESTART_OPT(1)
#define     USAGE(c)    (*ltmainOptions.pUsageProc)( &ltmainOptions, c )

/* * * * * *
 *
 *  Declare the ltmain option descriptor.
 */
#ifdef  __cplusplus
extern "C" {
#endif

extern tOptions   ltmainOptions;

/* * * * * *
 *
 *  Globals exported from the Object Code Library Management Tool option definitions
 */
extern tCC* pzHost;

#ifdef  __cplusplus
}
#endif
#endif /* LTMAIN_LTOPTS_H */
